//////////////////////////////////////////////////////////////////////////////
//       Eternity II puzzle solver, v1.0, (c) 2007 Miroslav Nemecek
//////////////////////////////////////////////////////////////////////////////

// Nmt - krom nhody tak monost setdit kostky v hashovacch tabulkch tak,
// aby mn ast barvy byly na zatku (a tak kter maj hodn barev najednou),
// aby se udaly dve, pozdji bude snadnj puzzle dokonit s kostkami kterch je hodn.
// - nefunguje, kostky maj stejn vhodnosti

// Nmt - pokldat kameny, kter maj nejmen anci na poloen jinde. Nap. kad
// polko obsahuje seznam kamen kter se tam mohou poloit, po poloen novho kamene
// se okoln seznamy aktualizuj. .... Poet monost poloen = 4 x zcela voln polka 
// + vechny ty, kde se me pipojit. Poet zcela volnch polek je pro vechny kameny stejn,
// ale potom zbvaj ty pozice "napojovac". Asi by hodn kamen mlo stejn poet "napojen",
// v takovm ppad zatm to vybrat nhodn A pitom po poloen kamene by se celkov poet
// monost poloen pro vechny jet nepoloen kameny ml snit co nejmn. No prost aby
// objem toho tlesa, co by byl ohranien hrac plochou a dle tmi poty monost poloen byl
// co nejvt. kdy by se rozhodlo o poloen toho konkrtnho kamene, tak toto poloen sn
// poty monost u ostatnch zbvajcch kamen, tak toto snen aby bylo co nejmen
// Mt evidenci ke kadmu polku, kolik se na nho me poloit kamen. V tu chvli vyhodnotit,
// kter polko je na tom nejh a rozhodovat, jak kmen tam poloit no a to takov, jeho
// poloen co nejmn sn poty monost v dalm kole. ... toto lze si pedstavit jako 3D
// objekt, zkladna ta plocha a ty poty monost pro kad polko jako vektory kolmo na tu plochu
// Mirku to by bylo zajmav rozhodovat o poloen dle kriteria "objemov integrl mus bt pro
// pt kolo maximln" A tm objemem se m na mysli suma monost vech jet volnch polek
// plus suma monost vech jet nepoloench kamen. Nepromlm to, ale podvdom mi k, e
// tento objemov integrl se stle bude zmenovat, ne? Neme se najednou jeho hodnota zvtit
// Akort to jeho zmenovn bude mt rznou derivaci, take se snait o to, neboli rozhodovat
// tak, aby to sniovn bylo co nejpomalej no a mus se dojt ke konci, ne?
// no tak ono asi v danou situaci bude platit, e vcero kamen objem integrlu sn stejn.
// Tak kter v tu chvli? No udl se analza pro vechny o jeden krok dopedu. Atd.
// a po x krocch bude vdt, e poloen toho konkrtnho kamene zpsob pro ptch x poloen
// co nejmen snen integrlu ... toho "objemu", neboli monost poloen
// Takto:
// - postm pro vechny voln polka kolik kamen (a jejich rotac) se me udlat
// - postm pro vechny nepoloen kameny kolikrt rzn se daj na desku poloit (brt v vahu i jejich rotace)
// - tyto dv sumy dohromady seten to je ten n "objemov integrl hry" jeho hodnota je s kadm
//   poloenm kamenem men a dojde k nule
// No a te zanu s vbrem jednoho kamene na jedno pole
// asi x kamen se bude moci poloit stejnkrt a y polek bude mt tak stejnou hodnotu
// proto polom prvn kmen a vyhodnotm novou situaci, vrtm ho a polom druh kmen atd
// a tak dle a nakonec budu vidt "do budoucna" ale jenom o jeden krok. Urit v tom budoucnu bude
// zase vcero kamen a ploek na tom stejn, take znovu takov przkum atd. Toto zkoumn urit
// bude konvergovat, a se zjist co je nejlep pro co nejvzdlenj budoucnost
// a to se udl atd
// No chtlo by to njakou umlou inteligenci, kter bys to takto nastnil a ona by to naprogramovala,e?
// Varianta 3D metody:
// - evidovat ke kadmu polku "poet monost polka" = "skre polka" (= kolik rznch kamen se na
// nho d poloit a to i s jeho ppadnma rotacema)
// - evidovat ke kadmu kameni "poet monost kamene" = "skre kamene" (= na kolik rznch polek se 
// d poloit a to i s jeho ppadnma rotacema)
// - pro vechny polka s nejnim stejnm skre zjistit, jak se poloen kamene s co nejnim skre
// na toto polko promtne do nov spotanch skre polek a kamen
// - jestlie bude existovat takov poloen kamena na polko, po kterm se suma skre vech zbvajcch
// polek a kamen zmen o co nejmn, tak toto poloen bude to prav a vznikne nov vchoz nulov situace
// - jestlie bude existovat vcero poloen, kter budou mt novou sumu skre polek a kamen stejnou, tak atd.
// No dle to nerozepisuji, jsou tu rzn monosti, ale tak m napad, e toto by se eilo njakou tou tzv.
// "rekurz", pomoc kter by se analza "zavrtvala hloubji a hloubji do budoucna", a by se zskalo slo
// hodnotc danou verzi atd

#pragma warning(disable : 4996)

#define		USEHINTS				// flag, use hints

//////////////////////////////////////////////////////////////////////////////
// Constants

#define		WIDTH	16				// width of area
#define		HEIGHT	16				// height of area
#define		BLOCKS	(WIDTH*HEIGHT)	// number of blocks (=256)
#define		COLORS	23				// number of colors (with border)
#define		COLBITS	5				// number of bits per color
#define		COLNUM	(1 << COLBITS)	// number of colors in hash tables (=32)
#define		COLNUM0	1				// size of hash list with no color
#define		COLNUM1	COLORS			// size of hash list with 1 color (=23)
#define		COLNUM2	(COLORS*COLNUM)	// size of hash list with 2 colors (=736)
#define		COLNUM3	(COLNUM2*COLNUM) // size of hash list with 3 colors (=23552)
#define		COLNUM4	(COLNUM3*COLNUM) // size of hash list with 4 colors (=753664)
#define		EDGE	0				// edge color
#define		ATOMNUM	1024			// number of atoms
#define		HASHNUM	(3*3*3*3)		// number of hash tables
#define		MAXHASH	1000000			// size of hash buffer (=974704)
#define		HINTFLG	HASHNUM			// hint block flag (on board)

// Hints
#define		H0BLOCK	138				// hint 0 block (=block 139)
#define		H0SPIN	2				// hint 0 spin
#define		H0POSX	7				// hint 0 position X
#define		H0POSY	8				// hint 0 position Y
#define		H0POS	(H0POSY*WIDTH+H0POSX) // hint 0 position (I,8)

#ifdef USEHINTS
#define		HINTNUM	3				// number of hints

#define		H1BLOCK	180				// hint 1 block (=block 181)
#define		H1SPIN	3				// hint 1 spin
#define		H1POSX	2				// hint 1 position X
#define		H1POSY	13				// hint 1 position Y
#define		H1POS	(H1POSY*WIDTH+H1POSX) // hint 1 position (N,3)

#define		H2BLOCK	254				// hint 2 block (=block 255)
#define		H2SPIN	3				// hint 2 spin
#define		H2POSX	13				// hint 2 position X
#define		H2POSY	2				// hint 2 position Y
#define		H2POS	(H2POSY*WIDTH+H2POSX) // hint 2 position (C,14)
#else // USEHINTS
#define		HINTNUM	1				// number of hints
#endif // USEHINTS

// Direction and turns - from top side to the right (i.e. in clock direction)
enum {
	DIR_UP		= 0,				// UP direction
	DIR_RIGHT	= 1,				// RIGHT direction
	DIR_DOWN	= 2,				// DOWN direction
	DIR_LEFT	= 3,				// LEFT direction
};

// Random mode
enum {
	RAND_UNSORT,					// blocks are unsorted (sorted numerical)
	RAND_SORT,						// blocks are sorted with its weight
	RAND_RANDOM,					// randomize

	RAND_NUM						// number of modes
};

// Paths
enum {
	PATH_ROWSDOWN = 0,				// rows down
	PATH_ROWSALT,					// alternate rows
	PATH_ROWSALTUP,					// alternate rows going up
	PATH_AROUND,					// around the board
	PATH_TAROUND,					// triple around the board

	PATH_NUM						// number of paths
};

// Color types of sides
enum {
	COL_X = 0,						// color is not determined
	COL_E = 1,						// color is board edge
	COL_C = 2,						// valid color

	COLT							// number of color types
};

//////////////////////////////////////////////////////////////////////////////
// Structures

#pragma pack (push, 4)

// Block (4 bytes)
struct CBlock {
	BYTE	Color[4];				// colors in all directions
};

// Atom (8 bytes) (on change update CAtom in Attack.asm)
struct CAtom {
	BYTE	Block;					// block number
	BYTE	Spin;					// block spin (quarter-turns clockwise)
	WORD	Weight;					// atom weight (heavy atoms goes first)
	BYTE	Color[4];				// colors in all directions
};

// Hash list (8 bytes) (on change update CHash in Attack.asm)
struct CHash {
	CAtom**	List;					// list of atoms
	int		Num;					// number of atoms in the list
};

// Field (20 bytes) (on change update CField in Attack.asm)
struct CField {
	CAtom**	Atom;					// saved pointer to atom list (NULL=none)
	BYTE	Color[4];				// colors in all directions
	CField*	Next;					// next field
	CField*	Prev;					// previous field
	long	Jump;					// jump address (or hash list index)
};

#pragma pack (pop)

//////////////////////////////////////////////////////////////////////////////
// Externals for assembler

extern "C" void Attack();
extern "C" void DispState();
extern "C" void SaveBest();

extern "C" struct CField Board[];
extern "C" struct CField* StartField;
extern "C" BYTE	Used[];
extern "C" BOOL DoReset;
extern "C" struct CField* CurrentPos;

extern "C" struct CHash
	Hxxxx[],HExxx[],HCxxx[],HxExx[],HEExx[],HCExx[],HxCxx[],HECxx[],HCCxx[],
	HxxEx[],HExEx[],HCxEx[],HxEEx[],HEEEx[],HCEEx[],HxCEx[],HECEx[],HCCEx[],
	HxxCx[],HExCx[],HCxCx[],HxECx[],HEECx[],HCECx[],HxCCx[],HECCx[],HCCCx[],
	HxxxE[],HExxE[],HCxxE[],HxExE[],HEExE[],HCExE[],HxCxE[],HECxE[],HCCxE[],
	HxxEE[],HExEE[],HCxEE[],HxEEE[],HEEEE[],HCEEE[],HxCEE[],HECEE[],HCCEE[],
	HxxCE[],HExCE[],HCxCE[],HxECE[],HEECE[],HCECE[],HxCCE[],HECCE[],HCCCE[],
	HxxxC[],HExxC[],HCxxC[],HxExC[],HEExC[],HCExC[],HxCxC[],HECxC[],HCCxC[],
	HxxEC[],HExEC[],HCxEC[],HxEEC[],HEEEC[],HCEEC[],HxCEC[],HECEC[],HCCEC[],
	HxxCC[],HExCC[],HCxCC[],HxECC[],HEECC[],HCECC[],HxCCC[],HECCC[],HCCCC[];

//////////////////////////////////////////////////////////////////////////////
// Strategy path

#define	XXXX		0x87			// stop field

const BYTE StartFields[PATH_NUM] = {
	0x00,							// PATH_ROWSDOWN
	0x00,							// PATH_ROWSALT
	0x00,							// PATH_ROWSALTUP
	0x0F,							// PATH_AROUND
	0xF0,							// PATH_TAROUND
};

const BYTE Strategy[BLOCKS*PATH_NUM] = {

// PATH_ROWSDOWN (rows in down direction)
//00  01   02   03   04   05   06   07    08   09   0A   0B   0C   0D   0E   0F
#ifdef USEHINTS
0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08, 0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F,0x10,//00
0x11,0x12,0x13,0x14,0x15,0x16,0x17,0x18, 0x19,0x1A,0x1B,0x1C,0x1D,0x1E,0x1F,0x20,//10
0x21,0x22,0x23,0x24,0x25,0x26,0x27,0x28, 0x29,0x2A,0x2B,0x2C,0x2E,XXXX,0x2F,0x30,//20
0x31,0x32,0x33,0x34,0x35,0x36,0x37,0x38, 0x39,0x3A,0x3B,0x3C,0x3D,0x3E,0x3F,0x40,//30
0x41,0x42,0x43,0x44,0x45,0x46,0x47,0x48, 0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,0x50,//40
0x51,0x52,0x53,0x54,0x55,0x56,0x57,0x58, 0x59,0x5A,0x5B,0x5C,0x5D,0x5E,0x5F,0x60,//50
0x61,0x62,0x63,0x64,0x65,0x66,0x67,0x68, 0x69,0x6A,0x6B,0x6C,0x6D,0x6E,0x6F,0x70,//60
0x71,0x72,0x73,0x74,0x75,0x76,0x77,0x78, 0x79,0x7A,0x7B,0x7C,0x7D,0x7E,0x7F,0x80,//70

0x81,0x82,0x83,0x84,0x85,0x86,0x88,XXXX, 0x89,0x8A,0x8B,0x8C,0x8D,0x8E,0x8F,0x90,//80
0x91,0x92,0x93,0x94,0x95,0x96,0x97,0x98, 0x99,0x9A,0x9B,0x9C,0x9D,0x9E,0x9F,0xA0,//90
0xA1,0xA2,0xA3,0xA4,0xA5,0xA6,0xA7,0xA8, 0xA9,0xAA,0xAB,0xAC,0xAD,0xAE,0xAF,0xB0,//A0
0xB1,0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,0xB8, 0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF,0xC0,//B0
0xC1,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7,0xC8, 0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF,0xD0,//C0
0xD1,0xD3,XXXX,0xD4,0xD5,0xD6,0xD7,0xD8, 0xD9,0xDA,0xDB,0xDC,0xDD,0xDE,0xDF,0xE0,//D0
0xE1,0xE2,0xE3,0xE4,0xE5,0xE6,0xE7,0xE8, 0xE9,0xEA,0xEB,0xEC,0xED,0xEE,0xEF,0xF0,//E0
0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,0xF8, 0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF,XXXX,//F0
#else // USEHINTS
0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08, 0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F,0x10,//00
0x11,0x12,0x13,0x14,0x15,0x16,0x17,0x18, 0x19,0x1A,0x1B,0x1C,0x1D,0x1E,0x1F,0x20,//10
0x21,0x22,0x23,0x24,0x25,0x26,0x27,0x28, 0x29,0x2A,0x2B,0x2C,0x2D,0x2E,0x2F,0x30,//20
0x31,0x32,0x33,0x34,0x35,0x36,0x37,0x38, 0x39,0x3A,0x3B,0x3C,0x3D,0x3E,0x3F,0x40,//30
0x41,0x42,0x43,0x44,0x45,0x46,0x47,0x48, 0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,0x50,//40
0x51,0x52,0x53,0x54,0x55,0x56,0x57,0x58, 0x59,0x5A,0x5B,0x5C,0x5D,0x5E,0x5F,0x60,//50
0x61,0x62,0x63,0x64,0x65,0x66,0x67,0x68, 0x69,0x6A,0x6B,0x6C,0x6D,0x6E,0x6F,0x70,//60
0x71,0x72,0x73,0x74,0x75,0x76,0x77,0x78, 0x79,0x7A,0x7B,0x7C,0x7D,0x7E,0x7F,0x80,//70

0x81,0x82,0x83,0x84,0x85,0x86,0x88,XXXX, 0x89,0x8A,0x8B,0x8C,0x8D,0x8E,0x8F,0x90,//80
0x91,0x92,0x93,0x94,0x95,0x96,0x97,0x98, 0x99,0x9A,0x9B,0x9C,0x9D,0x9E,0x9F,0xA0,//90
0xA1,0xA2,0xA3,0xA4,0xA5,0xA6,0xA7,0xA8, 0xA9,0xAA,0xAB,0xAC,0xAD,0xAE,0xAF,0xB0,//A0
0xB1,0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,0xB8, 0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF,0xC0,//B0
0xC1,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7,0xC8, 0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF,0xD0,//C0
0xD1,0xD2,0xD3,0xD4,0xD5,0xD6,0xD7,0xD8, 0xD9,0xDA,0xDB,0xDC,0xDD,0xDE,0xDF,0xE0,//D0
0xE1,0xE2,0xE3,0xE4,0xE5,0xE6,0xE7,0xE8, 0xE9,0xEA,0xEB,0xEC,0xED,0xEE,0xEF,0xF0,//E0
0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,0xF8, 0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF,XXXX,//F0
#endif // USEHINTS


// PATH_ROWSALT (alternate rows)
#ifdef USEHINTS
//00  01   02   03   04   05   06   07    08   09   0A   0B   0C   0D   0E   0F
0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08, 0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F,0xF0,//00
0x11,0x12,0x13,0x14,0x15,0x16,0x17,0x18, 0x19,0x1A,0x1B,0x1C,0x1D,0x1E,0x1F,0xE0,//10
0x21,0x22,0x23,0x24,0x25,0x26,0x27,0x28, 0x29,0x2A,0x2B,0x2C,0x2E,XXXX,0x2F,0xD0,//20
0x31,0x32,0x33,0x34,0x35,0x36,0x37,0x38, 0x39,0x3A,0x3B,0x3C,0x3D,0x3E,0x3F,0xC0,//30
0x41,0x42,0x43,0x44,0x45,0x46,0x47,0x48, 0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,0xB0,//40
0x51,0x52,0x53,0x54,0x55,0x56,0x57,0x58, 0x59,0x5A,0x5B,0x5C,0x5D,0x5E,0x5F,0xA0,//50
0x61,0x62,0x63,0x64,0x65,0x66,0x67,0x68, 0x69,0x6A,0x6B,0x6C,0x6D,0x6E,0x6F,0x90,//60
0x71,0x72,0x73,0x74,0x75,0x76,0x77,0x78, 0x79,0x7A,0x7B,0x7C,0x7D,0x7E,0x7F,0x80,//70

0x81,0x82,0x83,0x84,0x85,0x86,0x88,XXXX, 0x89,0x8A,0x8B,0x8C,0x8D,0x8E,0x8F,XXXX,//80
0x91,0x92,0x93,0x94,0x95,0x96,0x97,0x98, 0x99,0x9A,0x9B,0x9C,0x9D,0x9E,0x9F,0x70,//90
0xA1,0xA2,0xA3,0xA4,0xA5,0xA6,0xA7,0xA8, 0xA9,0xAA,0xAB,0xAC,0xAD,0xAE,0xAF,0x60,//A0
0xB1,0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,0xB8, 0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF,0x50,//B0
0xC1,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7,0xC8, 0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF,0x40,//C0
0xD1,0xD3,XXXX,0xD4,0xD5,0xD6,0xD7,0xD8, 0xD9,0xDA,0xDB,0xDC,0xDD,0xDE,0xDF,0x30,//D0
0xE1,0xE2,0xE3,0xE4,0xE5,0xE6,0xE7,0xE8, 0xE9,0xEA,0xEB,0xEC,0xED,0xEE,0xEF,0x20,//E0
0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,0xF8, 0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF,0x10,//F0
#else // USEHINTS
//00  01   02   03   04   05   06   07    08   09   0A   0B   0C   0D   0E   0F
0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08, 0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F,0xF0,//00
0x11,0x12,0x13,0x14,0x15,0x16,0x17,0x18, 0x19,0x1A,0x1B,0x1C,0x1D,0x1E,0x1F,0xE0,//10
0x21,0x22,0x23,0x24,0x25,0x26,0x27,0x28, 0x29,0x2A,0x2B,0x2C,0x2D,0x2E,0x2F,0xD0,//20
0x31,0x32,0x33,0x34,0x35,0x36,0x37,0x38, 0x39,0x3A,0x3B,0x3C,0x3D,0x3E,0x3F,0xC0,//30
0x41,0x42,0x43,0x44,0x45,0x46,0x47,0x48, 0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,0xB0,//40
0x51,0x52,0x53,0x54,0x55,0x56,0x57,0x58, 0x59,0x5A,0x5B,0x5C,0x5D,0x5E,0x5F,0xA0,//50
0x61,0x62,0x63,0x64,0x65,0x66,0x67,0x68, 0x69,0x6A,0x6B,0x6C,0x6D,0x6E,0x6F,0x90,//60
0x71,0x72,0x73,0x74,0x75,0x76,0x77,0x78, 0x79,0x7A,0x7B,0x7C,0x7D,0x7E,0x7F,0x80,//70

0x81,0x82,0x83,0x84,0x85,0x86,0x88,XXXX, 0x89,0x8A,0x8B,0x8C,0x8D,0x8E,0x8F,XXXX,//80
0x91,0x92,0x93,0x94,0x95,0x96,0x97,0x98, 0x99,0x9A,0x9B,0x9C,0x9D,0x9E,0x9F,0x70,//90
0xA1,0xA2,0xA3,0xA4,0xA5,0xA6,0xA7,0xA8, 0xA9,0xAA,0xAB,0xAC,0xAD,0xAE,0xAF,0x60,//A0
0xB1,0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,0xB8, 0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF,0x50,//B0
0xC1,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7,0xC8, 0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF,0x40,//C0
0xD1,0xD2,0xD3,0xD4,0xD5,0xD6,0xD7,0xD8, 0xD9,0xDA,0xDB,0xDC,0xDD,0xDE,0xDF,0x30,//D0
0xE1,0xE2,0xE3,0xE4,0xE5,0xE6,0xE7,0xE8, 0xE9,0xEA,0xEB,0xEC,0xED,0xEE,0xEF,0x20,//E0
0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,0xF8, 0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF,0x10,//F0
#endif // USEHINTS

// PATH_ROWSALTUP (alternate rows going up)
#ifdef USEHINTS
//00  01   02   03   04   05   06   07    08   09   0A   0B   0C   0D   0E   0F
0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08, 0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F,0xF0,//00
0x11,0x12,0x13,0x14,0x15,0x16,0x17,0x18, 0x19,0x1A,0x1B,0x1C,0x1D,0x1E,0x1F,0xD0,//10
0x21,0x22,0x23,0x24,0x25,0x26,0x27,0x28, 0x29,0x2A,0x2B,0x2C,0x2E,XXXX,0x2F,0xB0,//20
0x31,0x32,0x33,0x34,0x35,0x36,0x37,0x38, 0x39,0x3A,0x3B,0x3C,0x3D,0x3E,0x3F,0x90,//30
0x41,0x42,0x43,0x44,0x45,0x46,0x47,0x48, 0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,0x70,//40
0x51,0x52,0x53,0x54,0x55,0x56,0x57,0x58, 0x59,0x5A,0x5B,0x5C,0x5D,0x5E,0x5F,XXXX,//50
0x61,0x62,0x63,0x64,0x65,0x66,0x67,0x68, 0x69,0x6A,0x6B,0x6C,0x6D,0x6E,0x6F,0x50,//60
0x71,0x72,0x73,0x74,0x75,0x76,0x77,0x78, 0x79,0x7A,0x7B,0x7C,0x7D,0x7E,0x7F,0x60,//70

0x81,0x82,0x83,0x84,0x85,0x86,0x88,XXXX, 0x89,0x8A,0x8B,0x8C,0x8D,0x8E,0x8F,0x40,//80
0x91,0x92,0x93,0x94,0x95,0x96,0x97,0x98, 0x99,0x9A,0x9B,0x9C,0x9D,0x9E,0x9F,0x80,//90
0xA1,0xA2,0xA3,0xA4,0xA5,0xA6,0xA7,0xA8, 0xA9,0xAA,0xAB,0xAC,0xAD,0xAE,0xAF,0x30,//A0
0xB1,0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,0xB8, 0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF,0xA0,//B0
0xC1,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7,0xC8, 0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF,0x20,//C0
0xD1,0xD3,XXXX,0xD4,0xD5,0xD6,0xD7,0xD8, 0xD9,0xDA,0xDB,0xDC,0xDD,0xDE,0xDF,0xC0,//D0
0xE1,0xE2,0xE3,0xE4,0xE5,0xE6,0xE7,0xE8, 0xE9,0xEA,0xEB,0xEC,0xED,0xEE,0xEF,0x10,//E0
0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,0xF8, 0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF,0xE0,//F0
#else // USEHINTS
//00  01   02   03   04   05   06   07    08   09   0A   0B   0C   0D   0E   0F
0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08, 0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F,0xF0,//00
0x11,0x12,0x13,0x14,0x15,0x16,0x17,0x18, 0x19,0x1A,0x1B,0x1C,0x1D,0x1E,0x1F,0xD0,//10
0x21,0x22,0x23,0x24,0x25,0x26,0x27,0x28, 0x29,0x2A,0x2B,0x2C,0x2D,0x2E,0x2F,0xB0,//20
0x31,0x32,0x33,0x34,0x35,0x36,0x37,0x38, 0x39,0x3A,0x3B,0x3C,0x3D,0x3E,0x3F,0x90,//30
0x41,0x42,0x43,0x44,0x45,0x46,0x47,0x48, 0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,0x70,//40
0x51,0x52,0x53,0x54,0x55,0x56,0x57,0x58, 0x59,0x5A,0x5B,0x5C,0x5D,0x5E,0x5F,XXXX,//50
0x61,0x62,0x63,0x64,0x65,0x66,0x67,0x68, 0x69,0x6A,0x6B,0x6C,0x6D,0x6E,0x6F,0x50,//60
0x71,0x72,0x73,0x74,0x75,0x76,0x77,0x78, 0x79,0x7A,0x7B,0x7C,0x7D,0x7E,0x7F,0x60,//70

0x81,0x82,0x83,0x84,0x85,0x86,0x88,XXXX, 0x89,0x8A,0x8B,0x8C,0x8D,0x8E,0x8F,0x40,//80
0x91,0x92,0x93,0x94,0x95,0x96,0x97,0x98, 0x99,0x9A,0x9B,0x9C,0x9D,0x9E,0x9F,0x80,//90
0xA1,0xA2,0xA3,0xA4,0xA5,0xA6,0xA7,0xA8, 0xA9,0xAA,0xAB,0xAC,0xAD,0xAE,0xAF,0x30,//A0
0xB1,0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,0xB8, 0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF,0xA0,//B0
0xC1,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7,0xC8, 0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF,0x20,//C0
0xD1,0xD2,0xD3,0xD4,0xD5,0xD6,0xD7,0xD8, 0xD9,0xDA,0xDB,0xDC,0xDD,0xDE,0xDF,0xC0,//D0
0xE1,0xE2,0xE3,0xE4,0xE5,0xE6,0xE7,0xE8, 0xE9,0xEA,0xEB,0xEC,0xED,0xEE,0xEF,0x10,//E0
0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,0xF8, 0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF,0xE0,//F0
#endif // USEHINTS

// PATH_AROUND (around the board)
#ifdef USEHINTS
//00  01   02   03   04   05   06   07    08   09   0A   0B   0C   0D   0E   0F
0xFF,0x10,0x20,0x0A,0x09,0x08,0x07,0x8F, 0x7F,0x6F,0x5F,0x4F,0x1C,0x2F,0x1F,0x0E,//00
0x11,0x02,0x05,0x14,0x15,0x16,0x17,0x18, 0x19,0x1A,0x2B,0x4E,0x2C,0x2E,0x1D,0x1E,//10
0xDF,0x12,0x32,0x33,0x25,0x26,0x27,0x28, 0x29,0x2A,0x3B,0x4D,0x3F,XXXX,0x0D,0xF0,//20
0x03,0x22,0x13,0x24,0x35,0x36,0x37,0x38, 0x39,0x3A,0x4B,0x4C,0x0B,0x3C,0x3D,0x3E,//30
0x04,0x31,0x23,0x34,0x54,0x44,0x45,0x46, 0x47,0x48,0x49,0x5B,0x5D,0x5E,0xDE,0xF3,//40
0x06,0x41,0x42,0x63,0x53,0x43,0x55,0x56, 0x57,0x58,0x59,0x4A,XXXX,0x6D,0x6E,0xCF,//50
0x77,0x51,0x52,0x64,0x74,0x67,0x65,0x68, 0x79,0x89,0x5A,0x6C,0x5C,0x7D,0x7E,0xBF,//60
0x60,0x61,0x62,0x83,0x73,0x66,0x88,0x86, 0x97,0x69,0x6A,0x7C,0x6B,0x8D,0x8E,0xAF,//70

0x50,0x71,0x72,0x84,0x94,0x75,0x76,XXXX, 0x78,0x99,0x7A,0x7B,0x8B,0x9D,0x9E,0x9F,//80
0xB1,0x81,0x82,0xA3,0x93,0xA5,0xB3,0x98, 0x96,0xA8,0x8A,0x9C,0x8C,0xAD,0xAE,0xF9,//90
0x40,0x91,0x92,0xA4,0xB4,0x85,0x95,0xA6, 0xA9,0xAA,0x9A,0x9B,0xAB,0xBD,0xBE,0xFA,//A0
0x30,0xE4,0xA1,0xB2,0xB5,0xC5,0xB7,0xC7, 0xB9,0xC9,0xCB,0xBC,0xAC,0xDC,0xCE,0xFB,//B0
0xC1,0xC2,0xC3,0xF4,0xA7,0xC6,0xB6,0xC8, 0xB8,0xCA,0xBA,0xBB,0xDB,0xEC,0xDD,0xFC,//C0
0x00,0xF2,XXXX,0xC0,0xA2,0xC4,0xD5,0xD6, 0xD7,0xD8,0xD9,0xDA,0xCC,0xCD,0xED,0xFD,//D0
0xE1,0xE2,0xD1,0xD3,0x1B,0xD4,0xE5,0xE6, 0xE7,0xE8,0xE9,0xEA,0xEB,0x21,0x01,0xEE,//E0
0xF1,0xE0,0xD0,0xE3,0xB0,0xA0,0x90,0x80, 0x70,0xF8,0xF7,0xF6,0xF5,0x0C,0xEF,0xFE,//F0
#else // USEHINTS
//00  01   02   03   04   05   06   07    08   09   0A   0B   0C   0D   0E   0F
0xFF,0x10,0x20,0x0A,0x09,0x08,0x07,0x8F, 0x7F,0x6F,0x5F,0x4F,0x1C,0x2F,0x1F,0x0E,//00
0x11,0x02,0x05,0x14,0x15,0x16,0x17,0x18, 0x19,0x1A,0x2B,0x4E,0x2C,0x2E,0x1D,0x1E,//10
0xDF,0x12,0x32,0x33,0x25,0x26,0x27,0x28, 0x29,0x2A,0x3B,0x4D,0x3F,0x0D,0x2D,0xF0,//20
0x03,0x22,0x13,0x24,0x35,0x36,0x37,0x38, 0x39,0x3A,0x4B,0x4C,0x0B,0x3C,0x3D,0x3E,//30
0x04,0x31,0x23,0x34,0x54,0x44,0x45,0x46, 0x47,0x48,0x49,0x5B,0x5D,0x5E,0xDE,0xF3,//40
0x06,0x41,0x42,0x63,0x53,0x43,0x55,0x56, 0x57,0x58,0x59,0x4A,XXXX,0x6D,0x6E,0xCF,//50
0x77,0x51,0x52,0x64,0x74,0x67,0x65,0x68, 0x79,0x89,0x5A,0x6C,0x5C,0x7D,0x7E,0xBF,//60
0x60,0x61,0x62,0x83,0x73,0x66,0x88,0x86, 0x97,0x69,0x6A,0x7C,0x6B,0x8D,0x8E,0xAF,//70

0x50,0x71,0x72,0x84,0x94,0x75,0x76,XXXX, 0x78,0x99,0x7A,0x7B,0x8B,0x9D,0x9E,0x9F,//80
0xB1,0x81,0x82,0xA3,0x93,0xA5,0xB3,0x98, 0x96,0xA8,0x8A,0x9C,0x8C,0xAD,0xAE,0xF9,//90
0x40,0x91,0x92,0xA4,0xB4,0x85,0x95,0xA6, 0xA9,0xAA,0x9A,0x9B,0xAB,0xBD,0xBE,0xFA,//A0
0x30,0xE4,0xA1,0xB2,0xB5,0xC5,0xB7,0xC7, 0xB9,0xC9,0xCB,0xBC,0xAC,0xDC,0xCE,0xFB,//B0
0xC1,0xC2,0xC3,0xF4,0xA7,0xC6,0xB6,0xC8, 0xB8,0xCA,0xBA,0xBB,0xDB,0xEC,0xDD,0xFC,//C0
0x00,0xD2,0xF2,0xC0,0xA2,0xC4,0xD5,0xD6, 0xD7,0xD8,0xD9,0xDA,0xCC,0xCD,0xED,0xFD,//D0
0xE1,0xE2,0xD1,0xD3,0x1B,0xD4,0xE5,0xE6, 0xE7,0xE8,0xE9,0xEA,0xEB,0x21,0x01,0xEE,//E0
0xF1,0xE0,0xD0,0xE3,0xB0,0xA0,0x90,0x80, 0x70,0xF8,0xF7,0xF6,0xF5,0x0C,0xEF,0xFE,//F0
#endif // USEHINTS

// PATH_TAROUND (Triple around the board)
#ifdef USEHINTS
//00  01   02   03   04   05   06   07    08   09   0A   0B   0C   0D   0E   0F
0x10,0x00,0x12,0x13,0x14,0x15,0x16,0x17, 0x18,0x19,0x1A,0x1B,0x0B,0x2C,0x1E,0x0E,//00
0x11,0x20,0x22,0x23,0x24,0x25,0x26,0x27, 0x28,0x29,0x2A,0x2B,0x0C,0x0D,0x1D,0x0F,//10
0x21,0x30,0x01,0x02,0x03,0x04,0x05,0x06, 0x07,0x08,0x09,0x0A,0x3C,XXXX,0x3F,0x1F,//20
0x31,0x32,0x40,0x34,0x44,0x36,0x37,0x38, 0x48,0x49,0x4A,0x3A,0x1C,0x3E,0x2E,0x2F,//30
0x41,0x42,0x50,0x33,0x45,0x35,0x56,0x46, 0x47,0x5A,0x39,0x3B,0x5B,0x3D,0x4D,0x4E,//40
0x51,0x52,0x60,0x43,0x53,0x54,0x57,0x58, 0x68,0x6A,0x59,0x4B,0x4C,0x4F,0x5D,0x5E,//50
0x61,0x62,0x70,0x64,0x65,0x55,0x76,0x66, 0x67,0x79,0x69,0x5C,0x7B,0x5F,0x6D,0x6E,//60
0x71,0x72,0x80,0x63,0x73,0x74,0x77,0x78, 0x88,XXXX,0x6B,0x8A,0x6C,0x6F,0x7D,0x7E,//70

0x81,0x82,0x90,0x84,0x85,0x75,0x97,XXXX, 0x86,0x7A,0x99,0x9B,0x8B,0x7F,0x8D,0x8E,//80
0x91,0x92,0xA0,0x83,0x93,0x94,0x98,0x96, 0xA8,0x89,0x7C,0x9A,0x8C,0x8F,0x9D,0x9E,//90
0xA1,0xA2,0xB0,0xA4,0xA5,0x95,0xB6,0xA6, 0xA7,0xAA,0xBA,0xAC,0x9C,0x9F,0xAD,0xAE,//A0
0xC0,0xC3,0xB1,0xA3,0xB3,0xB4,0xC6,0xB8, 0xC8,0xA9,0xCA,0xAB,0xBB,0xAF,0xBD,0xBE,//B0
0xC1,0xC2,0xB2,0xC4,0xC5,0xB5,0xC7,0xB7, 0xC9,0xB9,0xCB,0xCC,0xBC,0xBF,0xCD,0xCE,//C0
0xF2,0xE2,XXXX,0xF4,0xF5,0xF6,0xF7,0xF8, 0xF9,0xFA,0xFB,0xFC,0xFD,0xFF,0xCF,0xDE,//D0
0xE1,0xD1,0xD0,0xD3,0xD4,0xD5,0xD6,0xD7, 0xD8,0xD9,0xDA,0xDB,0xDC,0xDD,0xDF,0xEE,//E0
0xF1,0xE0,0xF3,0xE3,0xE4,0xE5,0xE6,0xE7, 0xE8,0xE9,0xEA,0xEB,0xEC,0xED,0xEF,0xFE,//F0
#else // USEHINTS
//00  01   02   03   04   05   06   07    08   09   0A   0B   0C   0D   0E   0F
0x10,0x00,0x12,0x13,0x14,0x15,0x16,0x17, 0x18,0x19,0x1A,0x1B,0x0B,0x2C,0x1E,0x0E,//00
0x11,0x20,0x22,0x23,0x24,0x25,0x26,0x27, 0x28,0x29,0x2A,0x2B,0x0C,0x0D,0x2D,0x0F,//10
0x21,0x30,0x01,0x02,0x03,0x04,0x05,0x06, 0x07,0x08,0x09,0x0A,0x3C,0x1D,0x3F,0x1F,//20
0x31,0x32,0x40,0x34,0x44,0x36,0x37,0x38, 0x48,0x49,0x4A,0x3A,0x1C,0x3E,0x2E,0x2F,//30
0x41,0x42,0x50,0x33,0x45,0x35,0x56,0x46, 0x47,0x5A,0x39,0x3B,0x5B,0x3D,0x4D,0x4E,//40
0x51,0x52,0x60,0x43,0x53,0x54,0x57,0x58, 0x68,0x6A,0x59,0x4B,0x4C,0x4F,0x5D,0x5E,//50
0x61,0x62,0x70,0x64,0x65,0x55,0x76,0x66, 0x67,0x79,0x69,0x5C,0x7B,0x5F,0x6D,0x6E,//60
0x71,0x72,0x80,0x63,0x73,0x74,0x77,0x78, 0x88,XXXX,0x6B,0x8A,0x6C,0x6F,0x7D,0x7E,//70

0x81,0x82,0x90,0x84,0x85,0x75,0x97,XXXX, 0x86,0x7A,0x99,0x9B,0x8B,0x7F,0x8D,0x8E,//80
0x91,0x92,0xA0,0x83,0x93,0x94,0x98,0x96, 0xA8,0x89,0x7C,0x9A,0x8C,0x8F,0x9D,0x9E,//90
0xA1,0xA2,0xB0,0xA4,0xA5,0x95,0xB6,0xA6, 0xA7,0xAA,0xBA,0xAC,0x9C,0x9F,0xAD,0xAE,//A0
0xC0,0xC3,0xB1,0xA3,0xB3,0xB4,0xC6,0xB8, 0xC8,0xA9,0xCA,0xAB,0xBB,0xAF,0xBD,0xBE,//B0
0xC1,0xC2,0xB2,0xC4,0xC5,0xB5,0xC7,0xB7, 0xC9,0xB9,0xCB,0xCC,0xBC,0xBF,0xCD,0xCE,//C0
0xF2,0xD2,0xE2,0xF4,0xF5,0xF6,0xF7,0xF8, 0xF9,0xFA,0xFB,0xFC,0xFD,0xFF,0xCF,0xDE,//D0
0xE1,0xD1,0xD0,0xD3,0xD4,0xD5,0xD6,0xD7, 0xD8,0xD9,0xDA,0xDB,0xDC,0xDD,0xDF,0xEE,//E0
0xF1,0xE0,0xF3,0xE3,0xE4,0xE5,0xE6,0xE7, 0xE8,0xE9,0xEA,0xEB,0xEC,0xED,0xEF,0xFE,//F0
#endif // USEHINTS

/*
// Empty
//00  01   02   03   04   05   06   07    08   09   0A   0B   0C   0D   0E   0F
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,//00
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,//10
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,0x00,XXXX,0x00,0x00,//20
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,//30
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,//40
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,//50
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,//60
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,//70

0x00,0x00,0x00,0x00,0x00,0x00,0x00,XXXX, 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,//80
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,//90
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,//A0
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,//B0
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,//C0
0x00,0x00,XXXX,0x00,0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,//D0
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,//E0
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,//F0
*/

};

//////////////////////////////////////////////////////////////////////////////
// Block color definition

const struct CBlock Block[BLOCKS] = {
	{	1,	2,	0,	0	},			// block 1
	{	1,	3,	0,	0	},			// block 2
	{	4,	2,	0,	0	},			// block 3
	{	2,	4,	0,	0	},			// block 4
	{	5,	1,	0,	1	},			// block 5
	{	6,	4,	0,	1	},			// block 6
	{	7,	1,	0,	1	},			// block 7
	{	7,	8,	0,	1	},			// block 8
	{	9,	2,	0,	1	},			// block 9
	{	10,	3,	0,	1	},			// block 10
	{	11,	4,	0,	1	},			// block 11
	{	12,	3,	0,	1	},			// block 12
	{	12,	8,	0,	1	},			// block 13
	{	13,	3,	0,	1	},			// block 14
	{	6,	1,	0,	4	},			// block 15
	{	14,	2,	0,	4	},			// block 16
	{	15,	8,	0,	4	},			// block 17
	{	16,	8,	0,	4	},			// block 18
	{	10,	4,	0,	4	},			// block 19
	{	11,	4,	0,	4	},			// block 20
	{	17,	3,	0,	4	},			// block 21
	{	18,	1,	0,	4	},			// block 22
	{	18,	8,	0,	4	},			// block 23
	{	19,	1,	0,	4	},			// block 24
	{	13,	1,	0,	4	},			// block 25
	{	5,	4,	0,	2	},			// block 26
	{	5,	2,	0,	2	},			// block 27
	{	6,	2,	0,	2 	},			// block 28
	{	14,	2,	0,	2	},			// block 29
	{	10,	8,	0,	2	},			// block 30
	{	11,	4,	0,	2	},			// block 31
	{	19,	2,	0,	2	},			// block 32
	{	12,	4,	0,	2	},			// block 33
	{	12,	3,	0,	2	},			// block 34
	{	20,	8,	0,	2	},			// block 35
	{	21,	3,	0,	2	},			// block 36
	{	14,	1,	0,	3	},			// block 37
	{	22,	8,	0,	3	},			// block 38
	{	9,	8,	0,	3	},			// block 39
	{	16,	4,	0,	3	},			// block 40
	{	16,	2,	0,	3	},			// block 41
	{	11,	1,	0,	3	},			// block 42
	{	11,	4,	0,	3	},			// block 43
	{	11,	2,	0,	3	},			// block 44
	{	17,	1,	0,	3	},			// block 45
	{	19,	3,	0,	3	},			// block 46
	{	12,	3,	0,	3	},			// block 47
	{	20,	3,	0,	3	},			// block 48
	{	5,	8,	0,	8	},			// block 49
	{	6,	1,	0,	8	},			// block 50
	{	6,	4,	0,	8	},			// block 51
	{	7,	1,	0,	8	},			// block 52
	{	10,	3,	0,	8	},			// block 53
	{	17,	3,	0,	8	},			// block 54
	{	17,	8,	0,	8	},			// block 55
	{	12,	2,	0,	8	},			// block 56
	{	20,	1,	0,	8	},			// block 57
	{	20,	8,	0,	8	},			// block 58
	{	13,	4,	0,	8	},			// block 59
	{	21,	2,	0,	8	},			// block 60
	{	7,	14,	5,	5	},			// block 61
	{	15,	10,	5,	5	},			// block 62
	{	6,	22,	5,	6	},			// block 63
	{	5,	12,	5,	14	},			// block 64
	{	14,	21,	5,	14 	},			// block 65
	{	15,	15,	5,	14 	},			// block 66
	{	9,	6,	5,	14 	},			// block 67
	{	19,	7,	5,	14	},			// block 68
	{	21,	12,	5,	14 	},			// block 69
	{	22,	10,	5,	22 	},			// block 70
	{	10,	18,	5,	22 	},			// block 71
	{	15,	14,	5,	9  	},			// block 72
	{	11,	17,	5,	9  	},			// block 73
	{	19,	11,	5,	9  	},			// block 74
	{	12,	22,	5,	9  	},			// block 75
	{	15,	11,	5,	16 	},			// block 76
	{	16,	11,	5,	16 	},			// block 77
	{	22,	20,	5,	10 	},			// block 78
	{	19,	22,	5,	10 	},			// block 79
	{	20,	13,	5,	10 	},			// block 80
	{	16,	14,	5,	11 	},			// block 81
	{	14,	14,	5,	17 	},			// block 82
	{	9,	17,	5,	17	},			// block 83
	{	14,	16,	5,	18 	},			// block 84
	{	7,	15,	5,	18	},			// block 85
	{	12,	18,	5,	18 	},			// block 86
	{	20,	19,	5,	18 	},			// block 87
	{	5,	13,	5,	19	},			// block 88
	{	7,	21,	5,	19	},			// block 89
	{	17,	20,	5,	19 	},			// block 90
	{	9,	18,	5,	12	},			// block 91
	{	16,	11,	5,	12 	},			// block 92
	{	16,	17,	5,	12 	},			// block 93
	{	17,	13,	5,	12 	},			// block 94
	{	18,	15,	5,	12 	},			// block 95
	{	13,	22,	5,	13 	},			// block 96
	{	17,	16,	5,	21 	},			// block 97
	{	19,	12,	5,	21 	},			// block 98
	{	13,	7,	5,	21	},			// block 99
	{	21,	13,	5,	21 	},			// block 100
	{	18,	11,	6,	6  	},			// block 101
	{	18,	20,	6,	6  	},			// block 102
	{	20,	16,	6,	6  	},			// block 103
	{	21,	7,	6,	6	},			// block 104
	{	17,	11,	6,	14 	},			// block 105
	{	22,	12,	6,	7  	},			// block 106
	{	16,	12,	6,	7  	},			// block 107
	{	17,	11,	6,	7  	},			// block 108
	{	20,	9,	6,	7	},			// block 109
	{	11,	18,	6,	15 	},			// block 110
	{	18,	11,	6,	15 	},			// block 111
	{	19,	16,	6,	22 	},			// block 112
	{	19,	20,	6,	22 	},			// block 113
	{	15,	17,	6,	9  	},			// block 114
	{	10,	18,	6,	9  	},			// block 115
	{	18,	9,	6,	9	},			// block 116
	{	21,	20,	6,	9  	},			// block 117
	{	22,	13,	6,	16 	},			// block 118
	{	20,	18,	6,	10 	},			// block 119
	{	12,	21,	6,	11 	},			// block 120
	{	15,	21,	6,	17 	},			// block 121
	{	7,	20,	6,	19	},			// block 122
	{	15,	16,	6,	19 	},			// block 123
	{	19,	11,	6,	19 	},			// block 124
	{	18,	21,	6,	12 	},			// block 125
	{	13,	11,	6,	12 	},			// block 126
	{	15,	7,	6,	20	},			// block 127
	{	16,	13,	6,	20 	},			// block 128
	{	17,	22,	6,	20 	},			// block 129
	{	19,	12,	6,	20 	},			// block 130
	{	7,	19,	6,	13	},			// block 131
	{	18,	15,	6,	13 	},			// block 132
	{	15,	20,	6,	21 	},			// block 133
	{	9,	17,	6,	21	},			// block 134
	{	17,	22,	6,	21 	},			// block 135
	{	20,	19,	6,	21 	},			// block 136
	{	19,	10,	14,	14	},			// block 137
	{	7,	22,	14,	7  	},			// block 138
	{	7,	9,	14,	7	},			// block 139
	{	7,	18,	14,	7  	},			// block 140
	{	16,	13,	14,	7 	},			// block 141
	{	11,	7,	14,	7  	},			// block 142
	{	20,	18,	14,	7 	},			// block 143
	{	13,	13,	14,	7 	},			// block 144
	{	22,	17,	14,	15	},			// block 145
	{	14,	18,	14,	22	},			// block 146
	{	14,	21,	14,	22	},			// block 147
	{	22,	15,	14,	22	},			// block 148
	{	11,	18,	14,	22	},			// block 149
	{	7,	9,	14,	16	},			// block 150
	{	17,	21,	14,	16	},			// block 151
	{	9,	9,	14,	10	},			// block 152
	{	9,	16,	14,	10 	},			// block 153
	{	21,	20,	14,	10	},			// block 154
	{	10,	10,	14,	17	},			// block 155
	{	10,	18,	14,	17	},			// block 156
	{	21,	10,	14,	17	},			// block 157
	{	10,	20,	14,	19	},			// block 158
	{	12,	7,	14,	19 	},			// block 159
	{	13,	13,	14,	12	},			// block 160
	{	7,	19,	14,	20 	},			// block 161
	{	15,	19,	14,	20	},			// block 162
	{	11,	9,	14,	21 	},			// block 163
	{	17,	20,	14,	21	},			// block 164
	{	22,	17,	7,	15 	},			// block 165
	{	17,	12,	7,	15 	},			// block 166
	{	22,	22,	7,	9  	},			// block 167
	{	9,	11,	7,	16	},			// block 168
	{	16,	13,	7,	16 	},			// block 169
	{	17,	12,	7,	10 	},			// block 170
	{	19,	20,	7,	10 	},			// block 171
	{	13,	9,	7,	10	},			// block 172
	{	11,	11,	7,	11 	},			// block 173
	{	18,	19,	7,	11 	},			// block 174
	{	10,	13,	7,	17 	},			// block 175
	{	10,	16,	7,	18 	},			// block 176
	{	15,	17,	7,	19 	},			// block 177
	{	18,	20,	7,	12 	},			// block 178
	{	12,	11,	7,	12 	},			// block 179
	{	10,	20,	7,	20 	},			// block 180
	{	9,	20,	7,	13	},			// block 181
	{	10,	9,	7,	13	},			// block 182
	{	16,	12,	15,	15	},			// block 183
	{	21,	10,	15,	22	},			// block 184
	{	16,	18,	15,	9 	},			// block 185
	{	12,	12,	15,	9 	},			// block 186
	{	13,	10,	15,	16	},			// block 187
	{	15,	13,	15,	10	},			// block 188
	{	22,	16,	15,	10	},			// block 189
	{	20,	16,	15,	10	},			// block 190
	{	22,	22,	15,	11	},			// block 191
	{	11,	19,	15,	11	},			// block 192
	{	9,	10,	15,	17 	},			// block 193
	{	13,	9,	15,	18 	},			// block 194
	{	13,	21,	15,	18	},			// block 195
	{	21,	11,	15,	18	},			// block 196
	{	9,	21,	15,	19 	},			// block 197
	{	16,	12,	15,	19	},			// block 198
	{	19,	19,	15,	19	},			// block 199
	{	16,	22,	15,	12	},			// block 190
	{	13,	12,	15,	20	},			// block 201
	{	21,	10,	15,	20	},			// block 202
	{	18,	16,	15,	13	},			// block 203
	{	18,	12,	15,	13	},			// block 204
	{	20,	22,	15,	13	},			// block 205
	{	21,	13,	15,	13	},			// block 206
	{	21,	10,	22,	22	},			// block 207
	{	16,	21,	22,	9 	},			// block 208
	{	12,	11,	22,	9 	},			// block 209
	{	9,	16,	22,	10 	},			// block 210
	{	20,	11,	22,	10	},			// block 211
	{	22,	20,	22,	11	},			// block 212
	{	12,	12,	22,	17	},			// block 213
	{	22,	19,	22,	18	},			// block 214
	{	17,	21,	22,	18	},			// block 215
	{	21,	13,	22,	18	},			// block 216
	{	16,	11,	22,	19	},			// block 217
	{	17,	18,	22,	20	},			// block 218
	{	9,	17,	22,	13 	},			// block 219
	{	9,	20,	22,	21 	},			// block 220
	{	13,	13,	22,	21	},			// block 221
	{	13,	21,	22,	21	},			// block 222
	{	18,	21,	9,	9  	},			// block 223
	{	19,	10,	9,	9  	},			// block 224
	{	20,	11,	9,	9  	},			// block 225
	{	16,	11,	9,	10 	},			// block 226
	{	18,	18,	9,	10 	},			// block 227
	{	16,	12,	9,	17 	},			// block 228
	{	10,	21,	9,	19 	},			// block 229
	{	20,	12,	9,	19 	},			// block 230
	{	18,	19,	9,	12 	},			// block 231
	{	18,	13,	9,	12 	},			// block 232
	{	16,	19,	16,	16	},			// block 233
	{	20,	17,	16,	10	},			// block 234
	{	10,	17,	16,	17	},			// block 235
	{	10,	19,	16,	17	},			// block 236
	{	18,	11,	16,	17	},			// block 237
	{	17,	20,	16,	18	},			// block 238
	{	11,	21,	16,	19	},			// block 239
	{	13,	11,	16,	19	},			// block 240
	{	10,	13,	16,	12	},			// block 241
	{	17,	13,	16,	12	},			// block 242
	{	11,	18,	10,	11	},			// block 243
	{	19,	12,	10,	11	},			// block 244
	{	21,	19,	10,	17	},			// block 245
	{	20,	21,	10,	13	},			// block 246
	{	13,	21,	11,	11	},			// block 247
	{	18,	17,	11,	17	},			// block 248
	{	17,	13,	11,	18	},			// block 249
	{	20,	13,	11,	19	},			// block 250
	{	21,	12,	17,	17	},			// block 251
	{	12,	18,	17,	18	},			// block 252
	{	20,	19,	18,	12	},			// block 253
	{	13,	20,	19,	20	},			// block 254
	{	20,	21,	19,	21	},			// block 255
	{	13,	21,	12,	21	},			// block 256
};

// Kamen 14,7,7,9 na pozici I,8, co je pozice nachzejc se v lev
// doln tvrtce celho hracho pole a to v jejm pravm hornm rohu.
// Hrac plocha se popisuje od levho hornho rohu a dky maj oznaen A, B, ...
// a sloupce 1, 2, .

// Povinn kmen:
// Kamen 14,7,7,9 na pozici I,8, co je pozice nachzejc se v lev
// doln tvrtce celho hracho pole a to v jejm pravm hornm rohu.
// Hrac plocha se popisuje od levho hornho rohu a dky maj oznaen A, B, ...
// a sloupce 1, 2, .

// Prvn kmen (prvn npovda):
// Na polko N3 pat kmen . 181 a to tak, e modr "kln" je nahoe

// Druh kmen (druh npovda):
// Na polko C14 pat kmen . 255 a to tak, e modr "kln" je vlevo
// Oba dva kameny jsou tedy 3x rotovan doprava o 90 st. ... ve smru h. ruiek
